package delegation_backend

// TODO think of getting rid of -L flags with relative paths

// #cgo LDFLAGS: -L../result
// #cgo LDFLAGS: -lmina_signer -lm
// #cgo CFLAGS: -w -I ../result/headers
// #include "crypto.h"
import "C"
import "unsafe"

func verifySig(pk *Pk, sig *Sig, data []byte, networkId uint8) bool {
	pkC := C.CString(string(pk[:]))
	defer C.free(unsafe.Pointer(pkC))
	sigC := C.CString(string(sig[:]))
	defer C.free(unsafe.Pointer(sigC))
	dataC := C.CString(string(data))
	defer C.free(unsafe.Pointer(dataC))
	return bool(C.verify_message_string(sigC, pkC, dataC, C.size_t(len(data)), C.uint8_t(networkId)))
}
